#include "card.h"
#include "suit.h"

#include <qpainter.h>
#include <qimage.h>

//##############################################################################
Card::Card( int value, Suit* suit ) {
	this->value = value;
	this->suit = suit;
	valueName = new QString();
	valueName->setNum(value);
	if (value == 11)
		*valueName = "J";
	else if (value == 12)
		*valueName = "Q";
	else if (value == 13)
		*valueName = "K";
	else if (value == 14)
		*valueName = "A";
//qDebug("Card::Card %d %s%s", value, valueName->latin1(), suit->getName().latin1() );
}

//##############################################################################
void Card::draw( QPainter* painter, int left, int top ) {
	//qDebug("Card::draw %p %d %d", painter, left, top );
	QRect rect( left, top, width, height );
	painter->setPen( Qt::black );
	painter->setBrush( Qt::white );
	painter->drawRoundRect( rect, 25, 25 );
    
	painter->setFont( QFont( "Courier", 12, QFont::Bold ) );
	rect = painter->boundingRect ( left+2, top+2, 30, 30, Qt::AlignLeft | Qt::AlignTop, "10" );
	painter->drawText( rect, Qt::AlignCenter, getValueName()->latin1() );
    
	QImage* suitImage =  suit->getImage();
	painter->drawImage( left+4, rect.bottom(), *suitImage );
	//qDebug("Card::draw end" );
}
