#include "deck.h"
#include "suit.h"

#include <stdlib.h>
#include <qdatetime.h>

Deck::Deck() {
	for(int value = 2; value <= 14; value++) {
		discards.append( new Card(value, SPADES) );
		discards.append( new Card(value, HEARTS) );
		discards.append( new Card(value, CLUBS) );
		discards.append( new Card(value, DIAMONDS) );
	}
	QTime time = QTime::currentTime();
	long seed = time.second()+(time.minute()*60)+(time.hour()*3600);
	srand48( seed ); // Seed random number generator
	shuffle();
}

Card* Deck::dealCard() {
	Card* card = deck.take(0);
	discards.append( card );
	return card;
}

void Deck::shuffle() {
	while (deck.count()>0)
		discards.append( deck.take(0) );
	for (int i=51; i>=0; i--) {
		deck.append( discards.take( (int)((drand48()*i)+0.5) ) );
	//qDebug( "Deck::shuffle %d %s", deck.getLast()->getValue(), deck.getLast()->getSuit()->getName().latin1() );
	}
}
