#ifndef HANDVIEW_H
#define HANDVIEW_H

#include <qwidget.h>
#include <qstring.h>

class Player;
class Card;
class QPushButton;
class QLabel;
class QVBoxLayout;

class HandView : public QWidget
{
	Q_OBJECT
public:
	QPushButton* button; // Button displayed when displayMessage() called

        HandView( QWidget *parent = 0, const char *name = 0 );
        ~HandView() {}
	void showHand( Player* player );
	void hideHand();
	void showMessage( QString message );
	void hideMessage();

signals:
	void  cardSelected( int cardIndex );

protected:
	void paintEvent( QPaintEvent* e );
	void mousePressEvent( QMouseEvent *e );

private:
	Player* player;
	QVBoxLayout* layout;
	QLabel* label;

	int calculateCardOffset();

};

#endif // HANDVIEW_H
