#include "tableview.h"
#include "card.h"
#include "game.h"
#include "player.h"
#include <qpainter.h>

TableView::TableView( QWidget *parent, const char *name ) : QWidget( parent, name )
{
//    layout->setMargin( 2 );
}

void TableView::paintEvent( QPaintEvent* e ) {
	Q_UNUSED(e);
	//qDebug("TableView::paintEvent start");
	QPainter p( this );

	// Draw player names
	p.setPen( black );
	p.setFont( QFont( "Courier", 14, QFont::Bold ) );
	QPoint center = rect().center();
	QRect fontRect = p.boundingRect ( 0, 0, 50, 50, Qt::AlignLeft | Qt::AlignTop, "X" );
	QRect textRect( 2, center.y()-((Card::height/2)+2+fontRect.height()), rect().right()-2, fontRect.height());
    
	// Draw trick cards

	int playerIndex = game->getCurrentPlayer();
	if (game->getTrickCard( playerIndex ) != NULL)
		game->getTrickCard( playerIndex )->draw( &p, center.x()-(Card::width/2), rect().bottom()-(2+fontRect.height()+2+Card::height) );
	p.setFont( QFont( "Courier", 14, QFont::Bold ) );
	p.drawText( rect(), AlignHCenter | AlignBottom, game->getPlayer(playerIndex)->getName() );

	playerIndex = (playerIndex+1) % 4;
	if (game->getTrickCard( playerIndex ) != NULL)
		game->getTrickCard( playerIndex )->draw( &p, 8, center.y()-(Card::height/2) );
	p.setFont( QFont( "Courier", 14, QFont::Bold ) );
        p.drawText( textRect, AlignLeft | AlignVCenter, game->getPlayer(playerIndex)->getName() );

	playerIndex = (playerIndex+1) % 4;
	if (game->getTrickCard( playerIndex ) != NULL)
		game->getTrickCard( playerIndex )->draw( &p, center.x()-(Card::width/2), 2+fontRect.height()+2 );
	p.setFont( QFont( "Courier", 14, QFont::Bold ) );
	p.drawText( rect(), AlignHCenter | AlignTop, game->getPlayer(playerIndex)->getName() );

	playerIndex = (playerIndex+1) % 4;
	if (game->getTrickCard( playerIndex ) != NULL)
		game->getTrickCard( playerIndex )->draw( &p, rect().right()-(8+Card::width), center.y()-(Card::height/2) );
	p.setFont( QFont( "Courier", 14, QFont::Bold ) );
	p.drawText( textRect, AlignRight | AlignVCenter, game->getPlayer(playerIndex)->getName() );

	//qDebug("TableView::paintEvent end");
};
